<template>
  <q-page padding class="height-0">
    <q-scroll-area v-if="!loading" class="full-height" :thumb-style="{right: '0', borderRadius: '4px', background: '#d12', opacity: .6, width: '10px'}">
      <q-card flat>
        <q-card-actions vertical>
          <q-btn v-if="canUpload" @click="startUpload" color="primary" size="lg" class="full-width"
            :loading="uploading" :percentage="currentUploadStats().progress"
          >
            Start uploading
            <br/>
            {{currentUploadStats().files}} files | {{humanStorageSize(currentUploadStats().total)}}
            <div slot="loading">
              <q-spinner-gears class="on-left" />
              Upload {{currentUploadStats().files}} files: {{Math.ceil(currentUploadStats().uploaded * 100 / currentUploadStats().total)}}% Loading
            </div>
          </q-btn>
          <q-btn v-if="uploading" @click="stopUpload" color="negative" flat class="full-width">
            Stop upload
          </q-btn>
        </q-card-actions>
      </q-card>
      <div class="row items-stretch gutter-sm">
        <div class="col-12 col-lg-6" v-for="camera in cameras" :key="camera.cam_id">
          <q-card flat>
            <q-card-title class="q-px-none">
              <div class="row items-center">
                <div class="col-auto row items-center text-grey-6 q-pr-sm">
                  <q-icon name="videocam" class="q-pr-xs" size="24px" />
                  Camera {{camera.cam_id}}
                </div>
                <q-input class="col" hide-underline placehoder="Camera name"
                  :value="camera.name"
                  :after="[{ icon: 'mode_edit', allowPropagation: true, }]"
                  @change="(val) => { camera.name = val; saveCameraName(camera) }"
                />
              </div>
              <q-btn v-if="cameraCanRemove(camera.cam_id)" size="sm" flat color="negative" icon="delete" @click="removeCamera(camera.cam_id)" slot="right" />
            </q-card-title>
            <div :class="{
              'no-shadow': !files[camera.cam_id].length,
              'bg-white shadow-1': files[camera.cam_id].length > 0,
            }">
              <q-list :separator="uploading" no-border class="no-padding q-mx-sm">
                <q-list-header v-if="uploading">
                  Upload {{currentUploadStats(camera.cam_id).files}} files
                  <template v-if="currentUploadStats(camera.cam_id).total > 0">
                    : {{Math.ceil(currentUploadStats(camera.cam_id).uploaded * 100 / currentUploadStats(camera.cam_id).total)}}% Loading
                  </template>
                </q-list-header>
                <q-item v-if="filesCnt[camera.cam_id].total > 0 && (!files[camera.cam_id].length || filesCnt[camera.cam_id].total > 20)">
                  <q-item-main>
                    <q-item-tile label>{{filesCnt[camera.cam_id].total}} files</q-item-tile>
                    <q-item-tile sublabel>{{filesCnt[camera.cam_id].checksum}} checksummed</q-item-tile>
                    <q-item-tile sublabel class="text-positive">{{filesCnt[camera.cam_id].uploaded}} uploaded</q-item-tile>
                    <q-item-tile sublabel class="text-negative">{{filesCnt[camera.cam_id].failed}} failed</q-item-tile>
                  </q-item-main>
                  <q-item-side right icon="clear" class="cursor-pointer" @click.native="fileRemoveAll(camera.cam_id)" />
                </q-item>
                <q-item v-else v-for="file in files[camera.cam_id]" :key="file.__fileId">
                  <q-item-side icon="movie" class="cursor-pointer" @click.native="openVideoPreview(file)" v-if="!uploading" />
                  <q-item-main>
                    <q-item-tile label class="text-truncate" :title="file.name">
                      <small>{{file.name}}</small>
                    </q-item-tile>
                    <q-item-tile sublabel v-if="!uploading">
                      <small v-if="file.__failed && file.__checksum && !file.__doneUploading">{{humanStorageSize(file.__uploaded)}} / </small>
                      <small>{{file.__size}}</small>
                    </q-item-tile>
                    <q-item-tile sublabel color="negative" v-if="file.__failed && file.__failedStatus">
                      {{file.__failedStatus}}
                    </q-item-tile>
                    <q-item-tile v-if="uploading" class="q-my-sm">
                      <q-progress animate
                        :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                        :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                      ></q-progress>
                    </q-item-tile>
                  </q-item-main>
                  <q-item-side right v-if="uploading && file.__failed" stamp="upload failed" color="negative" />
                  <q-item-side right v-if="!file.__failed" :stamp="file.__size" />
                  <q-item-side right v-if="file.__doneUploading && !file.__failed" icon="check" color="positive" />
                  <q-item-side right v-else icon="clear" class="cursor-pointer" @click.native="fileRemove(file, camera.cam_id)" />
                </q-item>
              </q-list>
              <q-card-separator v-if="fileCanAdd(camera.cam_id) && files[camera.cam_id].length > 0" class="q-mx-sm" />
              <q-card-actions v-if="fileCanAdd(camera.cam_id)"
                class="relative-position justify-center q-pa-lg"
                :style="!files[camera.cam_id].length ? 'border: 1px dashed #303030;' : ''"
              >
                <div class="absolute" style="z-index: 1; top: 0; padding: 2px 50px;">
                  <q-checkbox v-model="camera.__dir" label="Folder" color="primary" />
                </div>
                <div class="q-pa-lg" v-if="!files[camera.cam_id].length">
                  <img src="~assets/video_file_types.png" alt="" style="max-width: 100%; height: auto;" />
                </div>
                <div class="row col-12 justify-center">
                  <q-btn size="lg" color="primary" @click="filePick(camera.cam_id)">
                    Select your files to get started
                  </q-btn>
                </div>
                <div class="q-pt-lg">... or simply drop your Videos here.</div>
                <!-- <input type="file" :ref="`file_${ camera.cam_id }`"
                  class="q-uploader-input absolute-full cursor-pointer"
                  :multiple="multiple"
                  :accept="extensions"
                  :directory="camera.__dir"
                  :webkitdirectory="camera.__dir"
                  :allowdirs="camera.__dir"
                  @change="fileAdd($event, camera.cam_id)"
                /> -->
                <input type="file" :ref="`file_${ camera.cam_id }`"
                  class="q-uploader-input absolute-full cursor-pointer"
                  :multiple="multiple"
                  :directory="camera.__dir"
                  :webkitdirectory="camera.__dir"
                  :allowdirs="camera.__dir"
                  @change="fileAdd($event, camera.cam_id)"
                />
              </q-card-actions>
              <q-card-separator v-if="camera.videos.length" class="q-mx-sm" />
              <q-list v-if="camera.videos.length" separator no-border class="bg-white no-padding q-ma-xs"
                :class="{'shadow-1': !files[camera.cam_id].length}"
              >
                <q-list-header>Existing files</q-list-header>
                <q-item v-if="camera.videos.length > 10">
                  <q-item-main :label="`${ camera.videos.length } files`" />
                </q-item>
                <q-item v-else v-for="video in camera.videos" :key="video.upload_id">
                  <q-item-side v-if="video.raw_segment_url" icon="movie" class="cursor-pointer" @click.native="openVideoPreview(video.raw_segment_url)" />
                  <q-item-main>
                    <q-item-tile label class="text-truncate" :title="video.file_name">
                      <small>{{video.file_name}}</small>
                    </q-item-tile>
                    <q-item-tile sublabel v-if="!video.completed">
                      <small>{{humanStorageSize(video.uploaded)}} / </small>
                      <small>{{humanStorageSize(video.content_length)}}</small>
                    </q-item-tile>
                  </q-item-main>
                  <q-item-side right v-if="video.completed" icon="check" color="positive" />
                </q-item>
              </q-list>
            </div>
          </q-card>
        </div>
        <div class="col-12">
          <q-btn @click="addCamera()" color="faded" size="lg" class="q-mt-lg q-ml-sm">
            Add a Camera
          </q-btn>
        </div>
      </div>
    </q-scroll-area>
    <q-modal v-model="videoPreviewModalOpen" @close="closeVideoPreview()" content-classes="column full-height">
      <div class="col column q-ma-lg">
        <div class="col row justify-center items-center" v-if="videoPreview && videoPreview.url">
          <video ref="videoPreviewPlayer" :src="videoPreview.url" controls class="col" style="max-height: 100%;"></video>
        </div>
        <dl class="q-mt-lg horizontal" v-if="videoPreview && videoPreview.file">
          <dt class="text-weight-regular">Name:</dt>
          <dd class="break-all">{{videoPreview.file.name}}</dd>
          <dt class="text-weight-regular">Size:</dt>
          <dd class="break-all">{{humanStorageSize(videoPreview.file.size)}}</dd>
          <dt class="text-weight-regular">Duration:</dt>
          <dd class="break-all">{{videoDuration}}</dd>
          <dt class="text-weight-regular">Checksum:</dt>
          <dd class="break-all">{{videoPreview.file.__checksum}}</dd>
        </dl>
        <q-btn color="faded" size="lg" class="q-mt-lg" @click="closeVideoPreview()">Close</q-btn>
      </div>
    </q-modal>
    <q-inner-loading :visible="loading" />
  </q-page>
</template>

<script>
  import { format } from 'quasar';
  import asmCrypto from 'asmcrypto.js';
  import { CancelToken, isCancel } from 'axios';
  import { stringify } from 'qs';
  import { getRejectionMessage, showRejectionMessage, padLeft } from '../../utils';

  const crypto = new asmCrypto.SHA256();
  const { humanStorageSize } = format;
  const chunkSize = 5 * 1024 * 1024;
  const chunkMaxCount = 2;
  const reRange = /(?:bytes=)?\d+-(\d+)$/;
  let fileIdef = 0;

  function parseEndpoint(endpoint) {
    if (/^(https?:)?\/\//.test(endpoint)) return endpoint;
    return endpoint.replace('/video-processor-secured/', '');
  }

  function parseRange(range) {
    const r = reRange.exec(range);
    return r ? parseInt(r[1], 10) + 1 : 0;
  }

  export default {
    name: 'irwUpload',
    data() {
      return {
        cameras: [],
        files: {},
        filesCnt: {},
        uploading: false,
        multiple: true,
        // extensions: 'video/*,image/*,audio/*',
        videoPreview: null,
        videoPreviewModalOpen: false,
        loading: false,
      };
    },
    computed: {
      canUpload() {
        return Object.values(this.files).some((camera) => camera.some((file) => (file.__checksum || file.__progress_checksum > 0) && !file.__doneUploading));
      },
      videoDuration() {
        if (!this.$refs.videoPreviewPlayer || Number.isNaN(this.$refs.videoPreviewPlayer.duration)) {
          return 'N/A';
        }
        return `${ this.$refs.videoPreviewPlayer.duration } sec`;
      },
    },
    methods: {
      humanStorageSize,
      load(idLocation) {
        this.loading = true;
        if (this.cancel) this.cancel.cancel();
        this.cancel = CancelToken.source();
        return this.loadVideos(idLocation)
          .then((videos) => this.loadCameras(idLocation, videos))
          .catch(() => true)
          .then(() => {
            this.loading = false;
          });
      },
      loadVideos(idLocation) {
        return this.$http
          .get('/resumable_uploads/list', {
            params: {
              location_id: idLocation,
            },
            cancelToken: this.cancel.token,
          })
          .then((response) => {
            if (!response.data.results || !response.data.results.length) {
              return [];
            }
            return response.data.results;
          })
          .catch(() => []);
      },
      loadCameras(idLocation, videos) {
        return this.$http
          .get('/cameras/list', {
            params: {
              location_id: idLocation,
            },
            cancelToken: this.cancel.token,
          })
          .then((response) => {
            if (!response.data.results || !response.data.results.length) {
              return Promise.reject(new Error('There are no cameras available'));
            }
            this.cameras = response.data.results
              .sort((cam1, cam2) => (cam1.cam_id < cam2.cam_id ? -1 : 1))
              .map((cam) => ({
                ...cam,
                __dir: false,
                name: typeof cam.name !== 'string' || !cam.name.length ? `Camera ${ cam.cam_id }` : cam.name,
                videos: videos
                  .filter((v) => v.cam_id === cam.cam_id && v.file_name && v.upload_id)
                  .map((v) => ({
                    file_name: v.file_name,
                    completed: v.completed,
                    upload_id: v.upload_id,
                    uploaded: v.uploaded,
                    content_length: v.content_length,
                    uploaded_timestamp: v.uploaded_timestamp,
                    segm_start: v.segm_start,
                    segm_end: v.segm_end,
                    raw_segment_url: v.raw_segment_url,
                  })),
              }));
            this.files = response.data.results.reduce((acc, cam) => {
              acc[cam.cam_id] = [];
              return acc;
            }, {});
            this.filesCnt = response.data.results.reduce((acc, cam) => {
              acc[cam.cam_id] = {
                total: 0,
                checksum: 0,
                uploaded: 0,
                failed: 0,
                size_total: 0,
                size_uploaded: 0,
              };
              return acc;
            }, {});
            return response;
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error reading cameras.');
            }
            this.cameras = [];
            return Promise.reject(rejection);
          });
      },
      cameraCanRemove(camId) {
        return !this.files[camId] || !this.files[camId].length;
      },
      fileCanAdd(camId) {
        return !this.uploading && this.files[camId] && (this.multiple || this.files[camId].length === 0);
      },
      filePick(camId) {
        if (this.fileCanAdd(camId) && (this.$q.platform.is.mozilla || this.$q.platform.is.ie)) {
          this.$refs[`file_${ camId }`][0].click();
        }
      },
      fileAdd(e, camId) {
        if (!this.fileCanAdd(camId)) {
          return;
        }

        const existing = this.files[camId];
        const existingTest = this.files[camId].map((f) => f.__test);
        const reducer = (acc, file) => acc.then((files) => this.fileInit(file, camId, files, existingTest));

        this.files[camId] = [];
        Array.prototype.reduce
          .call(e.target.files, reducer, Promise.resolve([]))
          .then((files) => {
            this.$set(this.files, camId, existing.concat(files));
            this.$refs[`file_${ camId }`][0].value = '';
          });
      },
      fileRemoveAll(camId) {
        this.files[camId].map((file) => this.fileRemove(file, camId, true));
        this.$set(this.files, camId, []);
        this.$set(this.filesCnt, camId, {
          total: 0,
          checksum: 0,
          uploaded: 0,
          failed: 0,
          size_total: 0,
          size_uploaded: 0,
        });
      },
      fileRemove(file, camId, skipUpdate) {
        const id = file.__id;
        const done = file.__doneUploading;
        if (!done) {
          if (file.__cancelToken) {
            file.__cancelToken.cancel();
          }
          if (!skipUpdate && file.__checksum) {
            const payload = JSON.stringify({
              id: file.__checksum,
              name: file.name,
            });
            this.$http
              .post('/upload', payload, {
                params: {
                  uploadType: 'resumable',
                },
                headers: {
                  'X-Upload-Content-Type': file.type || 'application/octet-stream',
                  'X-Upload-Content-Length': file.size,
                  'Content-Type': 'application/json; charset=UTF-8',
                },
                noRetry: true,
              })
              .then((response) => this.$http.delete(parseEndpoint(response.headers.location)))
              .catch(() => {});
          }
        }
        file.__removed = true;
        if (!skipUpdate) {
          this.$set(this.files, camId, this.files[camId].filter((obj) => obj.__id !== id));
          this.filesCnt[camId].total -= 1;
          this.filesCnt[camId].checksum -= file.__checksum ? 1 : 0;
          this.filesCnt[camId].uploaded -= done ? 1 : 0;
          this.filesCnt[camId].failed -= file.__failed ? 1 : 0;
          this.filesCnt[camId].size_total -= file.size;
          this.filesCnt[camId].size_uploaded -= file.__uploaded;
        }
      },
      fileInit(file, camId, files, existing) {
        return new Promise((resolve) => {
          const __test = `${ file.name }#${ file.size }`;
          if (existing.includes(__test)) {
            resolve(files);
            return;
          }
          fileIdef += 1;
          file.__id = fileIdef;
          file.__test = __test;
          file.__checksum = null;
          file.__size = humanStorageSize(file.size);
          file.__doneUploading = false;
          file.__failed = false;
          file.__failedStatus = null;
          file.__uploaded = 0;
          file.__progress = 0;
          file.__progress_checksum = 0;
          file.__promise_checksum = this
            .fileChecksum(file, camId)
            .then((checksum) => {
              file.__checksum = checksum;
              this.filesCnt[camId].checksum += 1;
              return checksum;
            })
            .catch(() => {
              file.__progress_checksum = 0;
              return 0;
            })
            .then(() => {
              files.push(file);
              this.filesCnt[camId].total += 1;
              this.filesCnt[camId].size_total += file.size;
              resolve(files);
            });
        });
      },
      fileChecksum(file, camId) {
        const meta = this.parseFileName(file.name);
        const isIRW = meta && file.size < 100 * 1024 * 1024;
        if (isIRW) {
          return new Promise((resolve) => {
            crypto.reset();
            crypto.process([file.name, file.size].join('#'));
            file.__progress_checksum = 100;
            resolve(asmCrypto.bytes_to_hex(crypto.finish().result));
          });
        }
        return new Promise((resolve, reject) => {
          const blobSlice = File.prototype.slice || File.prototype.mozSlice || File.prototype.webkitSlice;
          const chunks = Math.ceil(file.size / chunkSize);
          const fileReader = new FileReader();
          let currentChunk = 0;

          function loadNext() {
            const start = currentChunk * chunkSize;
            const end = ((start + chunkSize) >= file.size) ? file.size : start + chunkSize;
            fileReader.readAsArrayBuffer(blobSlice.call(file, start, end));
          }

          crypto.reset();
          crypto.process([file.name, file.size].join('#'));

          fileReader.onload = (e) => {
            if (file.__removed) {
              reject();
            } else {
              try {
                crypto.process(e.target.result);
                if (currentChunk < chunkMaxCount || currentChunk > chunks - chunkMaxCount - 1) {
                  currentChunk += 1;
                } else {
                  currentChunk = chunks - chunkMaxCount;
                }
                file.__progress_checksum = (currentChunk * 100) / chunks;
                this.$set(this.files, camId, [...this.files[camId]]);
                if (currentChunk < chunks) {
                  loadNext();
                } else {
                  resolve(asmCrypto.bytes_to_hex(crypto.finish().result));
                }
              } catch (err) {
                reject(err);
              }
            }
          };

          fileReader.onerror = (err) => {
            reject(err);
          };

          loadNext();
        });
      },
      startUpload() {
        this.uploading = true;
        let q = Promise.resolve();
        Object.keys(this.files).forEach((camId) => {
          const camIdInt = parseInt(camId, 10);
          const camera = this.cameras.find((s) => s.cam_id === camIdInt);
          this.files[camId].forEach((file) => {
            this.filesCnt[camId].failed -= file.__failed ? 1 : 0;
            file.__failed = false;
            file.__failedStatus = null;
          });
          q = q.then(() => this.processUpload(camera)).catch(() => true);
        });
        return q.then(() => {
          this.uploading = false;
          return this.$http
            .post('/users/eventWrite', stringify({
              location_id: parseInt(this.$route.params.idLocation, 10),
              status: 'UPLOAD_FINISHED',
            }, { arrayFormat: 'brackets' }), {
              headers: {
                'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
              },
            })
            .catch((rejection) => rejection);
        });
      },
      processUpload(camera) {
        const camId = String(camera.cam_id);
        let files = [];
        if (camera.__dir || this.files[camId].length > 20) {
          const f = this.files[camId].find((file) => !file.__failed && !file.__removed && !file.__doneUploading && file.__progress_checksum > 0);
          if (f) {
            files.push(f);
          }
        } else {
          files = this.files[camId]
            .filter((file) => !file.__failed && !file.__removed && !file.__doneUploading && file.__progress_checksum > 0)
            .sort((a, b) => (a.size * (2 - (a.__progress_checksum / 100))) - (b.size * (2 - (b.__progress_checksum / 100))));
        }
        if (!files.length || !this.uploading) {
          return Promise.resolve();
        }
        const file = files[0];
        file.__cancelToken = CancelToken.source();
        const uploadPromise = () => new Promise((resolve, reject) => {
          if (!this.uploading || file.__removed || !file.__checksum) {
            return reject(new Error());
          }
          const uploadLength = file.size;
          let uploadOffset = 0;
          let endpoint = '/upload';
          const upload = (fileId) => {
            if (uploadOffset >= uploadLength) {
              return resolve({ fileId });
            }
            const blob = file.slice(uploadOffset, uploadOffset + chunkSize);
            return this.$http
              .put(endpoint, blob, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Type': file.type || 'application/octet-stream',
                  'Content-Range': `bytes ${ uploadOffset }-${ (uploadOffset + blob.size) - 1 }/${ uploadLength }`,
                },
                noRetry: true,
                onUploadProgress: (progressEvent) => {
                  const upl = file.__uploaded;
                  file.__uploaded = Math.min(uploadLength, uploadOffset + progressEvent.loaded);
                  this.filesCnt[camId].size_uploaded += file.__uploaded - upl;
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, camId, [...this.files[camId]]);
                  return progressEvent;
                },
              })
              .then((response) => {
                if (response.status === 201) {
                  return resolve({ fileId });
                }
                uploadOffset = parseRange(response.headers.range);
                return upload(response.data ? response.data.fileId : null);
              })
              .catch((rejection) => {
                if (!isCancel(rejection)) {
                  reject(new Error('Invalid Upload-Offset'));
                }
                return reject(rejection);
              });
          };
          const payload = JSON.stringify({
            id: file.__checksum,
            name: file.name,
            meta: {
              location_id: parseInt(this.$route.params.idLocation, 10),
              cam_id: camera.cam_id,
            },
          });
          return this.$http
            .post(endpoint, payload, {
              cancelToken: file.__cancelToken.token,
              params: {
                uploadType: 'resumable',
              },
              headers: {
                'X-Upload-Content-Type': file.type || 'application/octet-stream',
                'X-Upload-Content-Length': file.size,
                'Content-Type': 'application/json; charset=UTF-8',
              },
              noRetry: true,
            })
            .then((response) => {
              endpoint = parseEndpoint(response.headers.location);
              return endpoint;
            })
            .catch((rejection) => {
              if (rejection.response && rejection.response.status === 409) {
                endpoint = parseEndpoint(rejection.response.headers.location);
                return endpoint;
              }
              return Promise.reject(rejection);
            })
            .then(() => this.$http
              .put(endpoint, null, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Range': `*/${ file.size }`,
                  'Content-Type': file.type || 'application/octet-stream',
                },
                noRetry: true,
              })
              .then((response) => {
                if (response.status === 206) {
                  uploadOffset = parseRange(response.headers.range);
                  const upl = file.__uploaded;
                  file.__uploaded = uploadOffset;
                  this.filesCnt[camId].size_uploaded += file.__uploaded - upl;
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, camId, [...this.files[camId]]);
                  return upload();
                }
                file.__progress = 100;
                this.$set(this.files, camId, [...this.files[camId]]);
                return resolve(response);
              }))
            .catch(reject);
        });
        return file.__promise_checksum
          .then(uploadPromise)
          .then(() => {
            this.filesCnt[camId].uploaded += file.__doneUploading ? 0 : 1;
            file.__doneUploading = true;
            const meta = this.parseFileName(file.name);
            const isIRW = meta && file.size < 100 * 1024 * 1024;
            return this.$http
              .post('/resource/create', stringify({
                file: [file.__checksum],
                file_name: [`${ file.__checksum }.${ file.name.split('.').slice(-1).join('').toLowerCase() }`],
                overwrite: false,
                use_id_as_name: true,
                use_name_as_id: false,
                mime_type: file.type,
                type: isIRW ? 'RECORDED_SEGMENT' : 'RECORDED_SEGMENT_RAW',
                storage_server_id: 1,
                stop_on_error: true,
                metadata: JSON.stringify({
                  location_id: parseInt(this.$route.params.idLocation, 10),
                  cam_id: camera.cam_id,
                  rec_tag: camera.rec_tag,
                  file_name: file.name,
                  file_size: file.size,
                  file_type: file.type,
                  ...(meta || {}),
                  uploaded_timestamp: (new Date()).valueOf(),
                }),
              }, { arrayFormat: 'brackets' }), {
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
                },
              })
              .catch((rejection) => {
                const msg = getRejectionMessage(rejection, 'There was an error creating resource.');
                if (
                  !isCancel(rejection)
                  && msg.indexOf('Resource already exists') === -1
                  && msg.indexOf('Error transfering uploaded file to storage server: java.nio.file.NoSuchFileException') === -1
                ) {
                  showRejectionMessage(rejection, 'There was an error creating resource.');
                }
                return rejection;
              });
          })
          .catch((error) => {
            if (error !== true) {
              this.filesCnt[camId].failed += file.__failed ? 0 : 1;
              file.__failed = true;
              if (typeof error === 'string') {
                file.__failedStatus = error;
              } else if (isCancel(error)) {
                file.__failedStatus = 'Upload cancelled';
              } else {
                file.__failedStatus = getRejectionMessage(error, 'Error uploading - try again');
              }
            }
            return error;
          })
          .then(() => {
            this.$set(this.files, camId, [...this.files[camId]]);
            return this.processUpload(camera);
          });
      },
      stopUpload() {
        this.uploading = false;
        Object.values(this.files).forEach((camera) => {
          camera.forEach((file) => {
            const done = file.__doneUploading;
            if (!done && file.__cancelToken) {
              file.__cancelToken.cancel();
            }
          });
        });
      },
      openVideoPreview(videoPreview) {
        if (!videoPreview) {
          return;
        }
        if (typeof videoPreview === 'string') {
          this.videoPreview = {
            url: videoPreview,
            file: null,
          };
        } else {
          this.videoPreview = {
            url: URL.createObjectURL(videoPreview),
            file: videoPreview,
          };
        }
        this.videoPreviewModalOpen = true;
      },
      closeVideoPreview() {
        this.videoPreviewModalOpen = false;
        if (this.videoPreview && this.videoPreview.url) {
          URL.revokeObjectURL(this.videoPreview.url);
        }
        this.videoPreview = null;
      },
      addCamera() {
        return this.$http
          .post('/cameras/createCamera', stringify({
            location_id: this.$route.params.idLocation,
          }, { arrayFormat: 'brackets' }), {
            headers: {
              'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
            },
          })
          .then(() => this.load(this.$route.params.idLocation))
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error creating camera.');
            }
            return rejection;
          });
      },
      removeCamera(camId) {
        if (!this.cameraCanRemove(camId)) {
          return false;
        }
        return this.$http
          .post('/cameras/deleteCamera', stringify({
            location_id: this.$route.params.idLocation,
            cam_id: camId,
          }, { arrayFormat: 'brackets' }), {
            headers: {
              'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
            },
          })
          .then(() => this.load(this.$route.params.idLocation))
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error deleting camera.');
            }
            return rejection;
          });
      },
      parseFileName(fileName) {
        let meta = null;
        if (typeof fileName === 'string' && fileName.length > 0) {
          const match = fileName.match(/^(\d+)-(\d+)-([^-]+)-(\d+)-(\d+)/);
          if (match) {
            meta = {};
            meta.file_location_id = String(match[1]);
            meta.file_cam_id = String(match[2]);
            meta.recording_profile_name = String(match[3]);
            meta.tsStart = parseInt(match[4], 10);
            meta.tsEnd = parseInt(match[5], 10);
            meta.tsStartUser = meta.tsStart;
            meta.segm_start = meta.tsStartUser;
            meta.tsEndUser = meta.tsEnd;
            meta.segm_end = meta.tsEndUser;
            meta.tsDuration = meta.tsEnd - meta.tsStart;

            const duration = [meta.tsDuration];
            duration[1] = Math.floor(meta.tsDuration / 1000 / 60 / 60);
            duration[2] = Math.floor((meta.tsDuration - (duration[1] * 1000 * 60 * 60)) / 1000 / 60);
            duration[3] = Math.floor((meta.tsDuration - (duration[1] * 1000 * 60 * 60) - (duration[2] * 1000 * 60)) / 1000);
            duration[4] = meta.tsDuration - (duration[1] * 1000 * 60 * 60) - (duration[2] * 1000 * 60) - (duration[3] * 1000);
            meta.videoDuration = `${ duration[1] || '0' }:${ padLeft(duration[2] || '0') }:${ padLeft(duration[3] || '0') }.${ padLeft(duration[4] || '0', 3) }`;
          }
        }
        return meta;
      },
      currentUploadStats(camId) {
        if (camId) {
          const stats = this.filesCnt[camId];
          return {
            files: stats.total,
            total: stats.size_total,
            uploaded: stats.size_uploaded,
            progress: (stats.size_uploaded * 100) / stats.size_total,
          };
        }
        return Object.values(this.filesCnt).reduce((acc, stats) => ({
          files: acc.files + stats.total,
          total: acc.total + stats.size_total,
          uploaded: acc.uploaded + stats.size_uploaded,
          progress: ((acc.uploaded + stats.size_uploaded) * 100) / (acc.total + stats.size_total),
        }), {
          files: 0,
          total: 0,
          uploaded: 0,
          progress: 0,
        });
      },
      saveCameraName(camera) {
        if (typeof camera.name !== 'string' || !camera.name.length) {
          camera.name = `Camera ${ camera.cam_id }`;
        }
        return this.$http
          .post('/cameras/updateGroupInfo', stringify({
            location_id: parseInt(this.$route.params.idLocation, 10),
            cam_id: camera.cam_id,
            name: camera.name,
          }, { arrayFormat: 'brackets' }), {
            headers: {
              'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
            },
          })
          .catch((rejection) => {
            showRejectionMessage(rejection, 'There was an error changing camera name.');
            return rejection;
          });
      },
    },
    mounted() {
      this.load(this.$route.params.idLocation);
    },
    beforeRouteUpdate(to, from, next) {
      if (this.cancel) this.cancel.cancel();
      this
        .load(to.params.idLocation)
        .then(next);
    },
    beforeDestroy() {
      if (this.cancel) this.cancel.cancel();
    },
  };
</script>
